package com.clx.performance.param.feign.transport;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Getter
@Setter
@ToString
@NoArgsConstructor
public class OrderChildDriverInfoDTO {

//    @ApiModelProperty(value = "运单号", dataType="String", required = true)
//    private String childNo;
//    @ApiModelProperty(value = "司机ID", dataType="Integer", required = true)
//    private Integer driverId;

    @ApiModelProperty(value = "手机号", dataType="String", required = true)
    @NotBlank(message = "手机号不能为空")
    private String mobile;
    @ApiModelProperty(value = "姓名", dataType="String", required = true)
    @NotBlank(message = "姓名手机号不能为空")
    private String name;
    @ApiModelProperty(value = "性别1男2女", dataType="Integer", required = true)
    private Integer sex;

//    @ApiModelProperty(value = "头像相对地址", dataType="String", required = true)
//    private String headImg;
//    @ApiModelProperty(value = "钱包账号", dataType="String", required = true)
//    private String walletCode;

    @ApiModelProperty(value = "身份证号", dataType="String", required = true)
    @NotBlank(message = "身份证号不能为空")
    private String cardNo;
    @ApiModelProperty(value = "身份证有效期起始时间", dataType="String", required = true)
    @NotBlank(message = "身份证有效期起始时间不能为空")
    private String cardStartTime;
    @ApiModelProperty(value = "身份证有效期终止时间", dataType="String")
    private String cardEndTime;
    @ApiModelProperty(value = "是否是长期 0-非长期 1-长期", dataType="Integer", required = true)
    @NotNull(message = "是否是长期不能为空")
    private Integer cardLongTerm;
    @ApiModelProperty(value = "身份证正面图片地址", dataType="String", required = true)
    @NotBlank(message = "身份证正面图片地址不能为空")
    private String cardFrontImg;
    @ApiModelProperty(value = "身份证背面图片地址", dataType="String", required = true)
    @NotBlank(message = "身份证背面图片地址不能为空")
    private String cardBackImg;
    @ApiModelProperty(value = "手持身份证照片地址", dataType="String")
    private String faceCardImg;

    @ApiModelProperty(value = "驾驶证号码", dataType="String", required = true)
//    @NotBlank(message = "驾驶证号码不能为空")
    private String licenceNo;
    @ApiModelProperty(value = "初次领证日期", dataType="String", required = true)
//    @NotBlank(message = "初次领证日期不能为空")
    private String licenseTime;
    @ApiModelProperty(value = "驾照类型", dataType="String", required = true)
//    @NotBlank(message = "驾照类型不能为空")
    private String licenceClass;
    @ApiModelProperty(value = "驾驶证正面图片", dataType="String", required = true)
//    @NotBlank(message = "驾驶证正面图片不能为空")
    private String licenceImg;
    @ApiModelProperty(value = "驾驶证背面图片", dataType="String", required = true)
//    @NotBlank(message = "驾驶证背面图片不能为空")
    private String licenceBackImg;
    @ApiModelProperty(value = "驾驶证有效期起始时间", dataType="String", required = true)
//    @NotBlank(message = "驾驶证有效期起始时间不能为空")
    private String licenceStartTime;
    @ApiModelProperty(value = "驾驶证有效期终止时间", dataType="String", required = true)
//    @NotBlank(message = "驾驶证有效期终止时间不能为空")
    private String licenceEndTime;

//    @ApiModelProperty(value = "道路运输许可证图片地址", dataType="String", required = true)
//    @NotBlank(message = "道路运输许可证图片地址不能为空")
//    private String transportLicenceImg;

    @ApiModelProperty(value = "道路运输从业资格证号", dataType="String", required = true)
//    @NotBlank(message = "道路运输从业资格证号不能为空")
    private String occupationalLicenceNo;
    @ApiModelProperty(value = "道路运输从业资格证图片地址", dataType="String", required = true)
//    @NotBlank(message = "道路运输从业资格证图片地址不能为空")
    private String occupationalLicenceImg;
    @ApiModelProperty(value = "从业资格证有效期起始时间", dataType="String", required = true)
//    @NotBlank(message = "从业资格证有效期起始时间不能为空")
    private String occupationalStartTime;
    @ApiModelProperty(value = "从业资格证有效期终止时间", dataType="String", required = true)
//    @NotBlank(message = "从业资格证有效期终止时间不能为空")
    private String occupationalEndTime;

    @ApiModelProperty(value = "驾驶证发证机关", required = true)
//    @NotBlank(message = "驾驶证发证机关不能为空")
    private String licenceIssueOrganization;
    @ApiModelProperty(value = "身份证住址", required = true)
//    @NotBlank(message = "身份证住址不能为空")
    private String idCardAddress = "手动";

}
