package com.clx.performance.param.pc;

import com.msl.common.convertor.type.MoneyInConvert;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

import java.math.BigDecimal;

@ApiModel(description = "提现审批")
@Getter
@Setter
@ToString
@NoArgsConstructor
public class OwnerCaseOutApproveParam {

    @ApiModelProperty(value = "id", example = "1")
    private Integer id;

    @ApiModelProperty(value = "平台付款银行")
    private String platformPaymentBank;

    @ApiModelProperty(value = "平台付款银行账号")
    private String platformPaymentBankNumber;

    @ApiModelProperty(value = "付款凭证", example = "a.png")
    private String paymentProof;

    @ApiModelProperty(value = "平台付款金额", example = "11.21")
    @MoneyInConvert
    private BigDecimal platformPayBalance;

}
