package com.clx.performance.vo.pc.breakcontract.owner;

import com.msl.common.convertor.type.MoneyOutConvert;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

import java.math.BigDecimal;

/**
 * @author liruixin
 * Date 2023-10-24
 * Time 16:02
 */
@Getter
@Setter
@ToString
@NoArgsConstructor
public class PageOwnerBreakContractOwnerRecordVO {

    @ApiModelProperty("id")
    private Integer id;

    @ApiModelProperty("违约订单")
    private String orderNo;

    @ApiModelProperty("违约金")
    @MoneyOutConvert
    private BigDecimal figure;

    @ApiModelProperty("结算单编号")
    private String settlementNo;

    @ApiModelProperty("缴费状态：0未缴费;1已缴费")
    private String payStatusMsg;

    @ApiModelProperty("赔付状态：0未赔付;1已赔付")
    private String compensationStatusMsg;

    @ApiModelProperty("缴费状态：0未缴费;1已缴费 /赔付状态：0未赔付;1已赔付")
    private Integer payStatus;

    @ApiModelProperty("确认状态：0-确认中;1-已经确认;2-已驳回")
    private String confirmStatusMsg;

    @ApiModelProperty("确认状态：0-确认中;1-已经确认;2-已驳回")
    private Integer confirmStatus;

    @ApiModelProperty("驳回原因")
    private String rejectReason;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("违约时间")
    private String createTime;

    @ApiModelProperty("赔付时间")
    private String payTime;

}
