package com.clx.performance.constant;

/**
 * @Author: aiqingguo
 * @Description: 车辆预警-mq
 * @Date: 2023-10-19 15:10:10
 * @Version: 1.0
 */
public class RabbitKeyVehicleWarnConstants {

    private static final String PREFIX = "clx-performance.vehicleWarn.";
    private static final String EXCHANGE = ".exchange";
    private static final String QUEUE = ".queue";
    private static final String QUEUE_ROUTING_KEY = ".routing.key";
    private static final String DELAY_QUEUE = ".delay.queue";
    private static final String DELAY_ROUTING_KEY = ".delay.routing.key";
    private static final String DEAD_QUEUE = ".dead.queue";
    private static final String DEAD_ROUTING_KEY = ".dead.routing.key";

    private RabbitKeyVehicleWarnConstants() {
    }

    /**
     * 缺省交换机
     */
    public static final String DEFAULT_EXCHANGE = PREFIX +"default"+EXCHANGE;

    /**
     * 缺省延迟队列
     */
    public static final String DEFAULT_DELAY_QUEUE = PREFIX +"default"+DELAY_QUEUE;
    public static final String DEFAULT_DELAY_ROUTING_KEY = PREFIX +"default"+DELAY_ROUTING_KEY;
    public static final String DEFAULT_DEAD_QUEUE = PREFIX +"default"+DEAD_QUEUE;
    public static final String DEFAULT_DEAD_ROUTING_KEY = PREFIX +"default"+DEAD_ROUTING_KEY;

    /**
     * 新增
     */
    public static final String ORDER_CHILD_ADD_QUEUE = PREFIX +"orderChild.add"+QUEUE;
    public static final String ORDER_CHILD_ADD_ROUTING_KEY = PREFIX +"orderChild.add"+QUEUE_ROUTING_KEY;

    /**
     * 车辆预警
     */
    public static final String TRUCK_WARN_QUEUE = PREFIX +"truck.warn"+QUEUE;
    public static final String TRUCK_WARN_ROUTING_KEY = PREFIX +"truck.warn"+QUEUE_ROUTING_KEY;

    /**
     * 车辆预警通知
     */
    public static final String TRUCK_WARN_NOTICE_QUEUE = PREFIX +"truckWarn.notice"+QUEUE;
    public static final String TRUCK_WARN_NOTICE_ROUTING_KEY = PREFIX +"truckWarn.notice"+QUEUE_ROUTING_KEY;

}
