package com.clx.performance.dao.loan;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.clx.performance.mapper.loan.OwnerRepaymentMapper;
import com.clx.performance.model.loan.OwnerRepayment;
import com.clx.performance.param.pc.loan.carrier.PageCarrierOwnerRepaymentParam;
import com.clx.performance.param.pc.loan.carrier.PageOwnerRepaymentOfOwner;
import com.clx.performance.vo.pc.loan.carrier.OwnerRepaymentVO;
import com.msl.common.dao.BaseDao;

import java.util.List;

/**
 * @author kavin
 * Date 2024-01-20
 * Time 13:31
 */
public interface OwnerRepaymentDao extends BaseDao<OwnerRepaymentMapper, OwnerRepayment, Integer> {
    IPage<OwnerRepayment> pageOwnerRepayment(PageCarrierOwnerRepaymentParam param);

    IPage<OwnerRepaymentVO> pageByParam(PageOwnerRepaymentOfOwner param);

    /**
     * 查询未付款成功还款单
     * @param status
     * @param ownerUserNo
     * @return
     */
    List<OwnerRepayment> selectListByStatusAndOwnerUserNo(Integer status, Long ownerUserNo);

    void updateRePay(OwnerRepayment ownerRepayment);

    void updateStatusById(OwnerRepayment ownerRepayment);
}
