package com.clx.performance.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.msl.common.config.KeyColumn;
import com.msl.common.model.HasKey;
import lombok.*;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
* @Author: aiqinguo
* @Description: 磅单日志表
* @Date: 2023/09/19 13:16:57
* @Version: 1.0
*/

@Getter
@Setter
@NoArgsConstructor
@TableName(autoResultMap = true)
@Builder
@Accessors(chain = true)
@AllArgsConstructor
public class OrderChildPoundLog implements HasKey<Integer> {

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;                             //id
    private String childNo;                         //运单编号
    private Integer status;                         //审核状态 0-待审核，1-审核失败， 2-审核成功
    private String remark;                          //备注
    private Integer createType;                     //操作人类型1-货主， 2-承运端，3-司机
    private Long createBy;                          //操作人编号
    private String createName;                      //操作人名称
    private LocalDateTime createTime;                      //创建时间
    private LocalDateTime modifiedTime;                    //修改时间

    @KeyColumn("id")
    @Override
    public Integer gainKey() {
        return id;
    }


}