package com.clx.performance.model.breakcontract;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.msl.common.config.KeyColumn;
import com.msl.common.model.HasKey;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;

/**
 * @author liruixin
 * Date 2023-10-24
 * Time 16:02
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("break_contract_driver_record")
public class BreakContractDriverRecord  implements HasKey<Integer> {

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField("trigger_type")
    @ApiModelProperty("触发类型：1系统触发 2手动触发")
    private Integer triggerType;

    @TableField("break_contract_party_type")
    @ApiModelProperty("违约方类型：1平台 2货主 3车主")
    private Integer breakContractPartyType;

    @TableField("break_no")
    @ApiModelProperty(value = "违约单号", example = "")
    private String breakNo;

    @TableField("child_no")
    @ApiModelProperty("违约运单")
    private String childNo;

    @TableField("truck_no")
    @ApiModelProperty("车牌号")
    private String truckNo;

    @TableField("truck_own_user_no")
    @ApiModelProperty("车主用户编号")
    private Long truckOwnUserNo;

    @TableField("truck_own_name")
    @ApiModelProperty("车主名称")
    private String truckOwnName;

    @TableField("driver_user_no")
    @ApiModelProperty("司机用户编号")
    private Long driverUserNo;

    @TableField("driver_name")
    @ApiModelProperty("司机名称")
    private String driverName;

    @TableField("figure")
    @ApiModelProperty("违约金")
    private BigDecimal figure;

    @TableField("time_limit")
    @ApiModelProperty("接单时间限制（小时）")
    private BigDecimal timeLimit;

    @TableField("limit_time")
    @ApiModelProperty("接单限制时间")
    private LocalDateTime limitTime;

    @TableField("settlement_no")
    @ApiModelProperty("结算单编号")
    private String settlementNo;

    @TableField("remark")
    @ApiModelProperty("备注")
    private String remark;

    @TableField("create_by")
    @ApiModelProperty(value = "操作人编号", example = "")
    private Long createBy;

    @TableField("create_name")
    @ApiModelProperty(value = "操作人名称", example = "")
    private String createName;

    @TableField("create_time")
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @TableField("modified_time")
    @ApiModelProperty("修改时间")
    private LocalDateTime modifiedTime;

    @Override
    @KeyColumn("id")
    public Integer gainKey() {
    return this.id;
    }
}
